//+------------------------------------------------------------------+
//|                                                   VWAP_Close.mq4 |
//|                                                              STS |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "STS"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Indigo
#property indicator_width1 3
//---- input parameters
extern int n=1;
extern int shift=0;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,shift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for (int i=limit;i>=0;i--)
   {
      double sum1,sum2;
      int ntmp;
      sum1=0;
      sum2=0;
      for (ntmp=0;ntmp<=n;ntmp++){
         sum1=sum1+Close[i+ntmp]*Volume[i+ntmp];
         sum2=sum2+Volume[i+ntmp];
      }
      if (sum2!=0)
            ExtMapBuffer1[i]=sum1/sum2;
      else  ExtMapBuffer1[i]=Close[i];
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+